Speed up test archive compression
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2020 Cisco and/or its affiliates.
2 # Copyright (c) 2020 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install virtualenv==20.0.20 || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
197     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
198     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
199     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
200     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
201     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
202     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
203     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
204     # Directories created if not present:
205     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
206     # Functions called:
207     # - die - Print to stderr and exit.
208
209     set -exuo pipefail
210
211     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
212         die "Some error during locating of this source file."
213     }
214     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
215         die "Some error during dirname call."
216     }
217     # Current working directory could be in a different repo, e.g. VPP.
218     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
219     relative_csit_dir=$(git rev-parse --show-toplevel) || {
220         die "Git rev-parse failed."
221     }
222     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
223     popd || die "Popd failed."
224     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
225         die "Readlink failed."
226     }
227     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
228         die "Readlink failed."
229     }
230     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
231         die "Readlink failed."
232     }
233     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
234         die "Readlink failed."
235     }
236     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
237         die "Readlink failed."
238     }
239     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
240         die "Readlink failed."
241     }
242
243     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archive") || {
244         die "Readlink failed."
245     }
246     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
247     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
248         die "Readlink failed."
249     }
250     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
251     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
252         die "Readlink failed."
253     }
254     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
255 }
256
257
258 function compose_pybot_arguments () {
259
260     # Variables read:
261     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
262     # - DUT - CSIT test/ subdirectory, set while processing tags.
263     # - TAGS - Array variable holding selected tag boolean expressions.
264     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
265     # - TEST_CODE - The test selection string from environment or argument.
266     # Variables set:
267     # - PYBOT_ARGS - String holding part of all arguments for pybot.
268     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
269
270     set -exuo pipefail
271
272     # No explicit check needed with "set -u".
273     PYBOT_ARGS=("--loglevel" "TRACE")
274     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
275
276     case "${TEST_CODE}" in
277         *"device"*)
278             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
279             ;;
280         *"perf"*)
281             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
282             ;;
283         *)
284             die "Unknown specification: ${TEST_CODE}"
285     esac
286
287     EXPANDED_TAGS=()
288     for tag in "${TAGS[@]}"; do
289         if [[ ${tag} == "!"* ]]; then
290             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
291         else
292             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
293         fi
294     done
295 }
296
297
298 function copy_archives () {
299
300     # Create additional archive if workspace variable is set.
301     # This way if script is running in jenkins all will be
302     # automatically archived to logs.fd.io.
303     #
304     # Variables read:
305     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
306     #   Can be unset, then it speeds up manual testing.
307     # - ARCHIVE_DIR - Path to directory with content to be copied.
308     # Directories updated:
309     # - ${WORKSPACE}/archives/ - Created if does not exist.
310     #   Content of ${ARCHIVE_DIR}/ is copied here.
311     # Functions called:
312     # - die - Print to stderr and exit.
313
314     set -exuo pipefail
315
316     if [[ -n "${WORKSPACE-}" ]]; then
317         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
318         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
319     fi
320 }
321
322
323 function deactivate_docker_topology () {
324
325     # Deactivate virtual vpp-device topology by removing containers.
326     #
327     # Variables read:
328     # - NODENESS - Node multiplicity of desired testbed.
329     # - FLAVOR - Node flavor string, usually describing the processor.
330
331     set -exuo pipefail
332
333     case_text="${NODENESS}_${FLAVOR}"
334     case "${case_text}" in
335         "1n_skx" | "1n_tx2")
336             ssh="ssh root@172.17.0.1 -p 6022"
337             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
338             # The "declare -f" output is long and boring.
339             set +x
340             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
341                 die "Topology cleanup via shim-dcr failed!"
342             }
343             set -x
344             ;;
345         "1n_vbox")
346             enter_mutex || die
347             clean_environment || {
348                 die "Topology cleanup locally failed!"
349             }
350             exit_mutex || die
351             ;;
352         *)
353             die "Unknown specification: ${case_text}!"
354     esac
355 }
356
357
358 function die () {
359
360     # Print the message to standard error end exit with error code specified
361     # by the second argument.
362     #
363     # Hardcoded values:
364     # - The default error message.
365     # Arguments:
366     # - ${1} - The whole error message, be sure to quote. Optional
367     # - ${2} - the code to exit with, default: 1.
368
369     set -x
370     set +eu
371     warn "${1:-Unspecified run-time error occurred!}"
372     exit "${2:-1}"
373 }
374
375
376 function die_on_pybot_error () {
377
378     # Source this fragment if you want to abort on any failed test case.
379     #
380     # Variables read:
381     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
382     # Functions called:
383     # - die - Print to stderr and exit.
384
385     set -exuo pipefail
386
387     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
388         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
389     fi
390 }
391
392
393 function generate_tests () {
394
395     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
396     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
397     # The generation is done by executing any *.py executable
398     # within any subdirectory after copying.
399
400     # This is a separate function, because this code is called
401     # both by autogen checker and entries calling run_pybot.
402
403     # Directories read:
404     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
405     # Directories replaced:
406     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
407
408     set -exuo pipefail
409
410     rm -rf "${GENERATED_DIR}/tests" || die
411     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
412     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
413     cmd_line+=("-executable" "-name" "*.py")
414     # We sort the directories, so log output can be compared between runs.
415     file_list=$("${cmd_line[@]}" | sort) || die
416
417     for gen in ${file_list}; do
418         directory="$(dirname "${gen}")" || die
419         filename="$(basename "${gen}")" || die
420         pushd "${directory}" || die
421         ./"${filename}" || die
422         popd || die
423     done
424 }
425
426
427 function get_test_code () {
428
429     # Arguments:
430     # - ${1} - Optional, argument of entry script (or empty as unset).
431     #   Test code value to override job name from environment.
432     # Variables read:
433     # - JOB_NAME - String affecting test selection, default if not argument.
434     # Variables set:
435     # - TEST_CODE - The test selection string from environment or argument.
436     # - NODENESS - Node multiplicity of desired testbed.
437     # - FLAVOR - Node flavor string, usually describing the processor.
438
439     set -exuo pipefail
440
441     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
442     if [[ -z "${TEST_CODE}" ]]; then
443         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
444     fi
445
446     case "${TEST_CODE}" in
447         *"1n-vbox"*)
448             NODENESS="1n"
449             FLAVOR="vbox"
450             ;;
451         *"1n-skx"*)
452             NODENESS="1n"
453             FLAVOR="skx"
454             ;;
455        *"1n-tx2"*)
456             NODENESS="1n"
457             FLAVOR="tx2"
458             ;;
459         *"2n-skx"*)
460             NODENESS="2n"
461             FLAVOR="skx"
462             ;;
463         *"2n-zn2"*)
464             NODENESS="2n"
465             FLAVOR="zn2"
466             ;;
467         *"3n-skx"*)
468             NODENESS="3n"
469             FLAVOR="skx"
470             ;;
471         *"2n-clx"*)
472             NODENESS="2n"
473             FLAVOR="clx"
474             ;;
475         *"2n-dnv"*)
476             NODENESS="2n"
477             FLAVOR="dnv"
478             ;;
479         *"3n-dnv"*)
480             NODENESS="3n"
481             FLAVOR="dnv"
482             ;;
483         *"3n-tsh"*)
484             NODENESS="3n"
485             FLAVOR="tsh"
486             ;;
487         *)
488             # Fallback to 3-node Haswell by default (backward compatibility)
489             NODENESS="3n"
490             FLAVOR="hsw"
491             ;;
492     esac
493 }
494
495
496 function get_test_tag_string () {
497
498     # Variables read:
499     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
500     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
501     # - TEST_CODE - The test selection string from environment or argument.
502     # Variables set:
503     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
504     #   May be empty, or even not set on event types not adding comment.
505
506     # TODO: ci-management scripts no longer need to perform this.
507
508     set -exuo pipefail
509
510     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
511         case "${TEST_CODE}" in
512             *"device"*)
513                 trigger="devicetest"
514                 ;;
515             *"perf"*)
516                 trigger="perftest"
517                 ;;
518             *)
519                 die "Unknown specification: ${TEST_CODE}"
520         esac
521         # Ignore lines not containing the trigger word.
522         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}") || true
523         # The vpp-csit triggers trail stuff we are not interested in.
524         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
525         # (except relying on \s whitespace, \S non-whitespace and . both).
526         # The last string is concatenated, only the middle part is expanded.
527         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
528         # On parsing error, TEST_TAG_STRING probably stays empty.
529         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}") || true
530         if [[ -n "${TEST_TAG_STRING-}" ]]; then
531             test_tag_array=(${TEST_TAG_STRING})
532             if [[ "${test_tag_array[0]}" == "icl" ]]; then
533                 export GRAPH_NODE_VARIANT="icl"
534                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
535             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
536                 export GRAPH_NODE_VARIANT="skx"
537                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
538             elif [[ "${test_tag_array[0]}" == "hsw" ]]; then
539                 export GRAPH_NODE_VARIANT="hsw"
540                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
541             fi
542         fi
543     fi
544 }
545
546
547 function installed () {
548
549     # Check if the given utility is installed. Fail if not installed.
550     #
551     # Duplicate of common.sh function, as this file is also used standalone.
552     #
553     # Arguments:
554     # - ${1} - Utility to check.
555     # Returns:
556     # - 0 - If command is installed.
557     # - 1 - If command is not installed.
558
559     set -exuo pipefail
560
561     command -v "${1}"
562 }
563
564
565 function reserve_and_cleanup_testbed () {
566
567     # Reserve physical testbed, perform cleanup, register trap to unreserve.
568     # When cleanup fails, remove from topologies and keep retrying
569     # until all topologies are removed.
570     #
571     # Variables read:
572     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
573     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
574     # - BUILD_TAG - Any string suitable as filename, identifying
575     #   test run executing this function. May be unset.
576     # Variables set:
577     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
578     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
579     # Functions called:
580     # - die - Print to stderr and exit.
581     # - ansible_playbook - Perform an action using ansible, see ansible.sh
582     # Traps registered:
583     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
584
585     set -exuo pipefail
586
587     while true; do
588         for topo in "${TOPOLOGIES[@]}"; do
589             set +e
590             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
591             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
592             python3 "${scrpt}" "${opts[@]}"
593             result="$?"
594             set -e
595             if [[ "${result}" == "0" ]]; then
596                 # Trap unreservation before cleanup check,
597                 # so multiple jobs showing failed cleanup improve chances
598                 # of humans to notice and fix.
599                 WORKING_TOPOLOGY="${topo}"
600                 echo "Reserved: ${WORKING_TOPOLOGY}"
601                 trap "untrap_and_unreserve_testbed" EXIT || {
602                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
603                     untrap_and_unreserve_testbed "${message}" || {
604                         die "Teardown should have died, not failed."
605                     }
606                     die "Trap attempt failed, unreserve succeeded. Aborting."
607                 }
608                 # Cleanup + calibration checks.
609                 set +e
610                 ansible_playbook "cleanup, calibration"
611                 result="$?"
612                 set -e
613                 if [[ "${result}" == "0" ]]; then
614                     break
615                 fi
616                 warn "Testbed cleanup failed: ${topo}"
617                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
618             fi
619             # Else testbed is accessible but currently reserved, moving on.
620         done
621
622         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
623             # Exit the infinite while loop if we made a reservation.
624             warn "Reservation and cleanup successful."
625             break
626         fi
627
628         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
629             die "Run out of operational testbeds!"
630         fi
631
632         # Wait ~3minutes before next try.
633         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
634             die "Sleep time calculation failed."
635         }
636         echo "Sleeping ${sleep_time}"
637         sleep "${sleep_time}" || die "Sleep failed."
638     done
639 }
640
641
642 function run_pybot () {
643
644     # Run pybot with options based on input variables. Create output_info.xml
645     #
646     # Variables read:
647     # - CSIT_DIR - Path to existing root of local CSIT git repository.
648     # - ARCHIVE_DIR - Path to store robot result files in.
649     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
650     # - GENERATED_DIR - Tests are assumed to be generated under there.
651     # Variables set:
652     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
653     # Functions called:
654     # - die - Print to stderr and exit.
655
656     set -exuo pipefail
657
658     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
659     all_options+=("--noncritical" "EXPECTED_FAILING")
660     all_options+=("${EXPANDED_TAGS[@]}")
661
662     pushd "${CSIT_DIR}" || die "Change directory operation failed."
663     set +e
664     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
665     PYBOT_EXIT_STATUS="$?"
666     set -e
667
668     # Generate INFO level output_info.xml for post-processing.
669     all_options=("--loglevel" "INFO")
670     all_options+=("--log" "none")
671     all_options+=("--report" "none")
672     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
673     all_options+=("${ARCHIVE_DIR}/output.xml")
674     rebot "${all_options[@]}" || true
675     popd || die "Change directory operation failed."
676 }
677
678
679 function select_arch_os () {
680
681     # Set variables affected by local CPU architecture and operating system.
682     #
683     # Variables set:
684     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
685     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
686     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
687
688     set -exuo pipefail
689
690     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
691         die "Get OS release failed."
692     }
693
694     case "${os_id}" in
695         "ubuntu"*)
696             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
697             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
698             PKG_SUFFIX="deb"
699             ;;
700         "centos"*)
701             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
702             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
703             PKG_SUFFIX="rpm"
704             ;;
705         *)
706             die "Unable to identify distro or os from ${os_id}"
707             ;;
708     esac
709
710     arch=$(uname -m) || {
711         die "Get CPU architecture failed."
712     }
713
714     case "${arch}" in
715         "aarch64")
716             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
717             ;;
718         *)
719             ;;
720     esac
721 }
722
723
724 function select_tags () {
725
726     # Variables read:
727     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
728     # - TEST_CODE - String affecting test selection, usually jenkins job name.
729     # - DUT - CSIT test/ subdirectory, set while processing tags.
730     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
731     #   Can be unset.
732     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
733     # - BASH_FUNCTION_DIR - Directory with input files to process.
734     # Variables set:
735     # - TAGS - Array of processed tag boolean expressions.
736
737     set -exuo pipefail
738
739     # NIC SELECTION
740     start_pattern='^  TG:'
741     end_pattern='^ \? \?[A-Za-z0-9]\+:'
742     # Remove the TG section from topology file
743     sed_command="/${start_pattern}/,/${end_pattern}/d"
744     # All topologies DUT NICs
745     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
746                 | grep -hoP "model: \K.*" | sort -u)
747     # Selected topology DUT NICs
748     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
749                | grep -hoP "model: \K.*" | sort -u)
750     # All topologies DUT NICs - Selected topology DUT NICs
751     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
752         die "Computation of excluded NICs failed."
753     }
754
755     # Select default NIC tag.
756     case "${TEST_CODE}" in
757         *"3n-dnv"* | *"2n-dnv"*)
758             default_nic="nic_intel-x553"
759             ;;
760         *"3n-tsh"*)
761             default_nic="nic_intel-x520-da2"
762             ;;
763         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
764             default_nic="nic_intel-xxv710"
765             ;;
766         *"3n-hsw"* | *"mrr-daily-master")
767             default_nic="nic_intel-xl710"
768             ;;
769         *)
770             default_nic="nic_intel-x710"
771             ;;
772     esac
773
774     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
775     sed_nics_sub_cmd="sed -e s/ANDxxv710/ANDnic_intel-xxv710/"
776     sed_nics_sub_cmd+=" | sed -e s/ANDx710/ANDnic_intel-x710/"
777     sed_nics_sub_cmd+=" | sed -e s/ANDxl710/ANDnic_intel-xl710/"
778     sed_nics_sub_cmd+=" | sed -e s/ANDx520-da2/ANDnic_intel-x520-da2/"
779     sed_nics_sub_cmd+=" | sed -e s/ANDx553/ANDnic_intel-x553/"
780     sed_nics_sub_cmd+=" | sed -e s/ANDcx556a/ANDnic_mellanox-cx556a/"
781     sed_nics_sub_cmd+=" | sed -e s/ANDvic1227/ANDnic_cisco-vic-1227/"
782     sed_nics_sub_cmd+=" | sed -e s/ANDvic1385/ANDnic_cisco-vic-1385/"
783     # Tag file directory shorthand.
784     tfd="${JOB_SPECS_DIR}"
785     case "${TEST_CODE}" in
786         # Select specific performance tests based on jenkins job type variable.
787         *"ndrpdr-weekly"* )
788             readarray -t test_tag_array <<< $(sed 's/ //g' \
789                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
790                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
791             ;;
792         *"mrr-daily"* )
793             readarray -t test_tag_array <<< $(sed 's/ //g' \
794                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
795                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
796             ;;
797         *"mrr-weekly"* )
798             readarray -t test_tag_array <<< $(sed 's/ //g' \
799                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
800                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
801             ;;
802         *"report-iterative"* )
803             test_sets=(${TEST_TAG_STRING//:/ })
804             # Run only one test set per run
805             report_file=${test_sets[0]}.md
806             readarray -t test_tag_array <<< $(sed 's/ //g' \
807                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
808                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
809             ;;
810         *"report-coverage"* )
811             test_sets=(${TEST_TAG_STRING//:/ })
812             # Run only one test set per run
813             report_file=${test_sets[0]}.md
814             readarray -t test_tag_array <<< $(sed 's/ //g' \
815                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
816                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
817             ;;
818         * )
819             if [[ -z "${TEST_TAG_STRING-}" ]]; then
820                 # If nothing is specified, we will run pre-selected tests by
821                 # following tags.
822                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
823                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
824                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
825                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
826                                 "!dot1q" "!drv_avf")
827             else
828                 # If trigger contains tags, split them into array.
829                 test_tag_array=(${TEST_TAG_STRING//:/ })
830             fi
831             ;;
832     esac
833
834     # Blacklisting certain tags per topology.
835     #
836     # Reasons for blacklisting:
837     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
838     # TODO: Add missing reasons here (if general) or where used (if specific).
839     case "${TEST_CODE}" in
840         *"2n-skx"*)
841             test_tag_array+=("!ipsec")
842             ;;
843         *"3n-skx"*)
844             test_tag_array+=("!ipsechw")
845             # Not enough nic_intel-xxv710 to support double link tests.
846             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
847             ;;
848         *"2n-clx"*)
849             test_tag_array+=("!ipsec")
850             ;;
851         *"2n-zn2"*)
852             test_tag_array+=("!ipsec")
853             ;;
854         *"2n-dnv"*)
855             test_tag_array+=("!ipsechw")
856             test_tag_array+=("!memif")
857             test_tag_array+=("!srv6_proxy")
858             test_tag_array+=("!vhost")
859             test_tag_array+=("!vts")
860             test_tag_array+=("!drv_avf")
861             ;;
862         *"3n-dnv"*)
863             test_tag_array+=("!memif")
864             test_tag_array+=("!srv6_proxy")
865             test_tag_array+=("!vhost")
866             test_tag_array+=("!vts")
867             test_tag_array+=("!drv_avf")
868             ;;
869         *"3n-tsh"*)
870             # 3n-tsh only has x520 NICs which don't work with AVF
871             test_tag_array+=("!drv_avf")
872             test_tag_array+=("!ipsechw")
873             ;;
874         *"3n-hsw"*)
875             test_tag_array+=("!drv_avf")
876             # All cards have access to QAT. But only one card (xl710)
877             # resides in same NUMA as QAT. Other cards must go over QPI
878             # which we do not want to even run.
879             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
880             ;;
881         *)
882             # Default to 3n-hsw due to compatibility.
883             test_tag_array+=("!drv_avf")
884             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
885             ;;
886     esac
887
888     # We will add excluded NICs.
889     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
890
891     TAGS=()
892
893     # We will prefix with perftest to prevent running other tests
894     # (e.g. Functional).
895     prefix="perftestAND"
896     set +x
897     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
898         # Automatic prefixing for VPP jobs to limit the NIC used and
899         # traffic evaluation to MRR.
900         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
901             prefix="${prefix}mrrAND"
902         else
903             prefix="${prefix}mrrAND${default_nic}AND"
904         fi
905     fi
906     for tag in "${test_tag_array[@]}"; do
907         if [[ "${tag}" == "!"* ]]; then
908             # Exclude tags are not prefixed.
909             TAGS+=("${tag}")
910         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
911             # Badly formed tag expressions can trigger way too much tests.
912             set -x
913             warn "The following tag expression hints at bad trigger: ${tag}"
914             warn "Possible cause: Multiple triggers in a single comment."
915             die "Aborting to avoid triggering too many tests."
916         elif [[ "${tag}" == *"OR"* ]]; then
917             # If OR had higher precedence than AND, it would be useful here.
918             # Some people think it does, thus triggering way too much tests.
919             set -x
920             warn "The following tag expression hints at bad trigger: ${tag}"
921             warn "Operator OR has lower precedence than AND. Use space instead."
922             die "Aborting to avoid triggering too many tests."
923         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
924             # Empty and comment lines are skipped.
925             # Other lines are normal tags, they are to be prefixed.
926             TAGS+=("${prefix}${tag}")
927         fi
928     done
929     set -x
930 }
931
932
933 function select_topology () {
934
935     # Variables read:
936     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
937     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
938     # - CSIT_DIR - Path to existing root of local CSIT git repository.
939     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
940     # Variables set:
941     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
942     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
943     # Functions called:
944     # - die - Print to stderr and exit.
945
946     set -exuo pipefail
947
948     case_text="${NODENESS}_${FLAVOR}"
949     case "${case_text}" in
950         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
951         # TODO: Double link availability depends on NIC used.
952         "1n_vbox")
953             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
954             TOPOLOGIES_TAGS="2_node_single_link_topo"
955             ;;
956         "1n_skx" | "1n_tx2")
957             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
958             TOPOLOGIES_TAGS="2_node_single_link_topo"
959             ;;
960         "2n_skx")
961             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
962             TOPOLOGIES_TAGS="2_node_*_link_topo"
963             ;;
964         "2n_zn2")
965             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
966             TOPOLOGIES_TAGS="2_node_*_link_topo"
967             ;;
968         "3n_skx")
969             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
970             TOPOLOGIES_TAGS="3_node_*_link_topo"
971             ;;
972         "2n_clx")
973             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
974             TOPOLOGIES_TAGS="2_node_*_link_topo"
975             ;;
976         "2n_dnv")
977             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
978             TOPOLOGIES_TAGS="2_node_single_link_topo"
979             ;;
980         "3n_dnv")
981             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
982             TOPOLOGIES_TAGS="3_node_single_link_topo"
983             ;;
984         "3n_hsw")
985             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
986             TOPOLOGIES_TAGS="3_node_single_link_topo"
987             ;;
988         "3n_tsh")
989             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
990             TOPOLOGIES_TAGS="3_node_single_link_topo"
991             ;;
992         *)
993             # No falling back to 3n_hsw default, that should have been done
994             # by the function which has set NODENESS and FLAVOR.
995             die "Unknown specification: ${case_text}"
996     esac
997
998     if [[ -z "${TOPOLOGIES-}" ]]; then
999         die "No applicable topology found!"
1000     fi
1001 }
1002
1003
1004 function select_vpp_device_tags () {
1005
1006     # Variables read:
1007     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1008     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
1009     #   Can be unset.
1010     # Variables set:
1011     # - TAGS - Array of processed tag boolean expressions.
1012
1013     set -exuo pipefail
1014
1015     case "${TEST_CODE}" in
1016         # Select specific device tests based on jenkins job type variable.
1017         * )
1018             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1019                 # If nothing is specified, we will run pre-selected tests by
1020                 # following tags. Items of array will be concatenated by OR
1021                 # in Robot Framework.
1022                 test_tag_array=()
1023             else
1024                 # If trigger contains tags, split them into array.
1025                 test_tag_array=(${TEST_TAG_STRING//:/ })
1026             fi
1027             ;;
1028     esac
1029
1030     # Blacklisting certain tags per topology.
1031     #
1032     # Reasons for blacklisting:
1033     # - avf - AVF is not possible to run on enic driver of VirtualBox.
1034     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
1035     case "${TEST_CODE}" in
1036         *"1n-vbox"*)
1037             test_tag_array+=("!avf")
1038             test_tag_array+=("!vhost")
1039             ;;
1040         *)
1041             ;;
1042     esac
1043
1044     TAGS=()
1045
1046     # We will prefix with devicetest to prevent running other tests
1047     # (e.g. Functional).
1048     prefix="devicetestAND"
1049     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1050         # Automatic prefixing for VPP jobs to limit testing.
1051         prefix="${prefix}"
1052     fi
1053     for tag in "${test_tag_array[@]}"; do
1054         if [[ ${tag} == "!"* ]]; then
1055             # Exclude tags are not prefixed.
1056             TAGS+=("${tag}")
1057         else
1058             TAGS+=("${prefix}${tag}")
1059         fi
1060     done
1061 }
1062
1063 function untrap_and_unreserve_testbed () {
1064
1065     # Use this as a trap function to ensure testbed does not remain reserved.
1066     # Perhaps call directly before script exit, to free testbed for other jobs.
1067     # This function is smart enough to avoid multiple unreservations (so safe).
1068     # Topo cleanup is executed (call it best practice), ignoring failures.
1069     #
1070     # Hardcoded values:
1071     # - default message to die with if testbed might remain reserved.
1072     # Arguments:
1073     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1074     # Variables read (by inner function):
1075     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1076     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1077     # Variables written:
1078     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1079     # Trap unregistered:
1080     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1081     # Functions called:
1082     # - die - Print to stderr and exit.
1083     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1084
1085     set -xo pipefail
1086     set +eu  # We do not want to exit early in a "teardown" function.
1087     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1088     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1089     if [[ -z "${wt-}" ]]; then
1090         set -eu
1091         warn "Testbed looks unreserved already. Trap removal failed before?"
1092     else
1093         ansible_playbook "cleanup" || true
1094         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1095             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1096         }
1097         WORKING_TOPOLOGY=""
1098         set -eu
1099     fi
1100 }
1101
1102
1103 function warn () {
1104
1105     # Print the message to standard error.
1106     #
1107     # Arguments:
1108     # - ${@} - The text of the message.
1109
1110     set -exuo pipefail
1111
1112     echo "$@" >&2
1113 }